import { EngineConfig, Operation, Operator } from 'types';
interface OperationContext {
    data: Record<string, any>;
    prev: {
        args?: Record<string, any>;
        result?: any;
    };
    env: EngineConfig['env'];
}
export declare class Engine {
    config: EngineConfig;
    operators: Record<string, Operator>;
    constructor(operators: Record<string, Operator>, config: EngineConfig);
    static validateConfig(config: EngineConfig): void;
    static validateOperators(operators: Record<string, Operator>): void;
    static validateOperation(operation: Operation): void;
    runOperation(operation: Operation, dataSource?: Record<string, any>): Promise<any>;
    private executeOperation;
    mountOperatorInput(args: any, context: OperationContext): Promise<Record<string, any>>;
}
export {};
