"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Engine = void 0;
var lodash_1 = require("lodash");
var joi_1 = __importDefault(require("joi"));
var index_1 = require("./../operators/defaultOperators/index");
var validators_1 = require("../operators/validators");
var index_2 = require("./index");
var vallidators_1 = require("./vallidators");
var Engine = /** @class */ (function () {
    function Engine(operators, config) {
        Engine.validateOperators(operators);
        Engine.validateConfig(config);
        this.operators = __assign(__assign({}, index_1.defaultOperators), operators);
        this.config = __assign(__assign({}, index_2.defaultEngineConfig), config);
    }
    Engine.validateConfig = function (config) {
        var result = vallidators_1.engineConfigValidator.validate(config, { abortEarly: true });
        if (result.error) {
            throw new Error('Invalid config provided');
        }
    };
    Engine.validateOperators = function (operators) {
        var result = joi_1.default.object().pattern(/.*/, [validators_1.engineOperatorValidator]).validate(operators, { abortEarly: true });
        if (result.error) {
            throw new Error('Invalid operators config');
        }
    };
    Engine.validateOperation = function (operation) {
        var result = vallidators_1.operationValidator.validate(operation, { abortEarly: true });
        if (result.error) {
            throw result.error;
        }
    };
    Engine.prototype.runOperation = function (operation, dataSource) {
        if (dataSource === void 0) { dataSource = {}; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.executeOperation(operation, { data: dataSource, env: this.config.env, prev: {} })];
                }
                catch (error) {
                    throw new Error(error);
                }
                return [2 /*return*/];
            });
        });
    };
    Engine.prototype.executeOperation = function (operation, context) {
        var _a, _b, _c, _d;
        return __awaiter(this, void 0, void 0, function () {
            var operator, input, error, result;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        operator = this.operators[operation.operator];
                        if (!operator) {
                            throw new Error('Operator not found');
                        }
                        return [4 /*yield*/, this.mountOperatorInput(operation.args, context)];
                    case 1:
                        input = _e.sent();
                        if (operator.argsValidator) {
                            error = operator.argsValidator.validate(input).error;
                            if (error) {
                                throw new Error("Operation " + operator.name + " was provided wrong format");
                            }
                        }
                        return [4 /*yield*/, operator.handler(input)];
                    case 2:
                        result = _e.sent();
                        // Checking if we have nested operations
                        if (((_a = operation.onResult) === null || _a === void 0 ? void 0 : _a.onFalsy) || ((_b = operation.onResult) === null || _b === void 0 ? void 0 : _b.onTruthy)) {
                            lodash_1.set(context, ['prev'], {
                                result: result,
                                args: input,
                            });
                            if (result && ((_c = operation.onResult) === null || _c === void 0 ? void 0 : _c.onTruthy)) {
                                return [2 /*return*/, this.executeOperation(operation.onResult.onTruthy, context)];
                            }
                            if (!result && ((_d = operation.onResult) === null || _d === void 0 ? void 0 : _d.onFalsy)) {
                                return [2 /*return*/, this.executeOperation(operation.onResult.onFalsy, context)];
                            }
                        }
                        return [2 /*return*/, result];
                }
            });
        });
    };
    Engine.prototype.mountOperatorInput = function (args, context) {
        return __awaiter(this, void 0, void 0, function () {
            var argsType, argsIsArray, resultArray, _i, args_1, arg, operationResult, argsIsObject, isOperation, result, objectEntries, _a, objectEntries_1, _b, key, val, value;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        argsType = typeof args;
                        if (argsType === 'string') {
                            if (args.startsWith('$ctx.'))
                                return [2 /*return*/, lodash_1.get({ $ctx: context }, args)];
                            return [2 /*return*/, args];
                        }
                        if (['boolean', 'number'].includes(argsType)) {
                            return [2 /*return*/, args];
                        }
                        argsIsArray = lodash_1.isArray(args);
                        if (!argsIsArray) return [3 /*break*/, 5];
                        resultArray = [];
                        _i = 0, args_1 = args;
                        _c.label = 1;
                    case 1:
                        if (!(_i < args_1.length)) return [3 /*break*/, 4];
                        arg = args_1[_i];
                        return [4 /*yield*/, this.mountOperatorInput(arg, context)];
                    case 2:
                        operationResult = _c.sent();
                        resultArray.push(operationResult);
                        _c.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/, resultArray];
                    case 5:
                        argsIsObject = lodash_1.isPlainObject(args);
                        // If it's not string, number, boolean, array nor object, is not an allowed type
                        if (!argsIsObject) {
                            throw new Error("This type is not allowed " + args);
                        }
                        isOperation = lodash_1.get(args, 'operator');
                        if (isOperation) {
                            return [2 /*return*/, this.executeOperation(args, context)];
                        }
                        result = {};
                        objectEntries = Object.entries(args);
                        _a = 0, objectEntries_1 = objectEntries;
                        _c.label = 6;
                    case 6:
                        if (!(_a < objectEntries_1.length)) return [3 /*break*/, 9];
                        _b = objectEntries_1[_a], key = _b[0], val = _b[1];
                        return [4 /*yield*/, this.mountOperatorInput(val, context)];
                    case 7:
                        value = _c.sent();
                        lodash_1.set(result, [key], value);
                        _c.label = 8;
                    case 8:
                        _a++;
                        return [3 /*break*/, 6];
                    case 9: return [2 /*return*/, result];
                }
            });
        });
    };
    return Engine;
}());
exports.Engine = Engine;
