"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.divideOperator = exports.multiplyOperator = exports.subtractOperator = exports.addOperator = void 0;
var validators_1 = require("./validators");
exports.addOperator = {
    name: 'add',
    description: 'Add a list of numbers',
    argsValidator: validators_1.unlimittedNumbersListValidator,
    handler: function (_a) {
        var numbers = _a.numbers;
        return numbers.reduce(function (prev, n) { return prev + n; }, 0);
    },
};
exports.subtractOperator = {
    name: 'subtract',
    description: 'Subtract one number from another',
    argsValidator: validators_1.twoNumbersListValidator,
    handler: function (_a) {
        var numbers = _a.numbers;
        var firstNumber = numbers[0], secondNumber = numbers[1];
        return firstNumber - secondNumber;
    },
};
exports.multiplyOperator = {
    name: 'multiply',
    description: 'Multiplies a list of numbers',
    argsValidator: validators_1.unlimittedNumbersListValidator,
    handler: function (_a) {
        var numbers = _a.numbers;
        return numbers.reduce(function (prev, n) { return prev * n; }, 1);
    },
};
exports.divideOperator = {
    name: 'divide',
    description: 'Divides one number from another',
    argsValidator: validators_1.twoNumbersListValidator,
    handler: function (_a) {
        var numbers = _a.numbers;
        var firstNumber = numbers[0], secondNumber = numbers[1];
        return firstNumber / (secondNumber || 1);
    },
};
