"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lteOperator = exports.ltOperator = exports.gteOperator = exports.gtOperator = void 0;
var validators_1 = require("./validators");
exports.gtOperator = {
    name: 'gt',
    description: 'Checks if the first argument is greater than the second one',
    argsValidator: validators_1.twoNumbersListValidator,
    handler: function (_a) {
        var numbers = _a.numbers;
        var firstNumber = numbers[0], secondNumber = numbers[1];
        return firstNumber > secondNumber;
    },
};
exports.gteOperator = {
    name: 'gte',
    description: 'Checks if the first argument is greater than OR equal to the second one',
    argsValidator: validators_1.twoNumbersListValidator,
    handler: function (_a) {
        var numbers = _a.numbers;
        var firstNumber = numbers[0], secondNumber = numbers[1];
        return firstNumber >= secondNumber;
    },
};
exports.ltOperator = {
    name: 'lt',
    description: 'Checks if the first argument is less than the second one',
    argsValidator: validators_1.twoNumbersListValidator,
    handler: function (_a) {
        var numbers = _a.numbers;
        var firstNumber = numbers[0], secondNumber = numbers[1];
        return firstNumber < secondNumber;
    },
};
exports.lteOperator = {
    name: 'lte',
    description: 'Checks if the first argument is less than OR equal to the second one',
    argsValidator: validators_1.twoNumbersListValidator,
    handler: function (_a) {
        var numbers = _a.numbers;
        var firstNumber = numbers[0], secondNumber = numbers[1];
        return firstNumber <= secondNumber;
    },
};
